// CoilRdDlg.cpp : implementation file
//

#include "stdafx.h"
#include "CoilRd.h"
#include "CoilRdDlg.h"

#include "..\..\include\AdamTcpCE.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

wchar_t	szwIPAddress[20];

#define  DeviceID       0x01  // 0x01 indicate the 5000/TCP
#define  DEFAULT_PORT   502  // Port for Modbus/TCP
//-------- default timeout ------
int      iConnectionTimeout=5000;
int      iSendTimeout=5000;
int      iReceiveTimeout=5000;

int MbsToWcs (char* mbs, wchar_t* wcs)
{
	wchar_t g_wcConverter[256];
	size_t len = strlen (mbs);
	memset (g_wcConverter, 0, sizeof(g_wcConverter));
	if (len > 127) return NULL;
	mbstowcs(g_wcConverter, mbs, len);
	wcscpy(wcs, g_wcConverter);
	return len;
}

int WcsToMbs (wchar_t* wcs, char* mbs)
{
	char	g_mbConvert[256];
	size_t len = wcslen (wcs);
	if (len >= sizeof(g_mbConvert)) len = sizeof(g_mbConvert) - 1;
	wcstombs(g_mbConvert, wcs, len);
	strcpy(mbs, g_mbConvert);
	return len;
}

/////////////////////////////////////////////////////////////////////////////
// CCoilRdDlg dialog

CCoilRdDlg::CCoilRdDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCoilRdDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCoilRdDlg)
	m_strDeviceID = _T("");
	m_strIPAddress = _T("");
	m_strNoOfRead = _T("");
	m_strStartAddress = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCoilRdDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCoilRdDlg)
	DDX_Text(pDX, IDC_EDIT_DEVICEID, m_strDeviceID);
	DDX_Text(pDX, IDC_EDIT_IPADDRESS, m_strIPAddress);
	DDX_Text(pDX, IDC_EDIT_NO, m_strNoOfRead);
	DDX_Text(pDX, IDC_EDIT_STARTADDRESS, m_strStartAddress);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCoilRdDlg, CDialog)
	//{{AFX_MSG_MAP(CCoilRdDlg)
	ON_BN_CLICKED(IDC_EXIT, OnExit)
	ON_BN_CLICKED(IDC_READCOIL, OnReadcoil)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCoilRdDlg message handlers

BOOL CCoilRdDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	m_strIPAddress="172.18.1.193";
	m_strDeviceID="1";
	m_strStartAddress="1";
	m_strNoOfRead="8";

	SetDlgItemText(IDC_EDIT_IPADDRESS,m_strIPAddress);
	SetDlgItemText(IDC_EDIT_DEVICEID,m_strDeviceID);
	SetDlgItemText(IDC_EDIT_STARTADDRESS,m_strStartAddress);
	SetDlgItemText(IDC_EDIT_NO,m_strNoOfRead);

	// get the DLL version 
	char     szCh[20];
	//wchar_t  szwCh[20];
    int    iVersion;    
 
	iVersion=ADAMTCP_GetDLLVersion();
	_ltoa( iVersion, szCh, 16 );

	size_t len = strlen (szCh);
	wchar_t  wcConverter[20];

	memset (wcConverter, 0, sizeof(wcConverter));

	mbstowcs(wcConverter, szCh, len);
	//wsprintf(szwCh,"%s",szCh);
	SetDlgItemText(IDC_EDIT_DLLVER, wcConverter);

    //--- To initialize DLL to work ---
    int   iRetVal;

    iRetVal=ADAMTCP_Open();
    if( iRetVal!=0 )
    {
        MessageBox(_T("ADAMTCP_Open() Failure !!!"));
    }	
	
	//--- reset the content in CListBox ---
	((CListBox*)GetDlgItem(IDC_LIST_COILVALUE))->ResetContent();
	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CCoilRdDlg::OnExit() 
{
	// TODO: Add your control notification handler code here
    ADAMTCP_Close();	
	
	// TODO: Add your control notification handler code here
	CDialog::OnOK();
}

void CCoilRdDlg::OnReadcoil() 
{
	// TODO: Add your control notification handler code here
	// TODO: Add your control notification handler code here
    CString   strText,strTemp;
	int       i,j,iRetVal;
	WORD      wDeviceID;
    WORD      wStartAddress;
    WORD      wCount;
    WORD      wData[128];
	TCHAR	  szwTemp[80];

	// How many coils to read
	GetDlgItemText(IDC_EDIT_NO,szwTemp, 80*sizeof(TCHAR));
	wCount = (WORD)_wtoi(szwTemp);
	if( wCount<0 || wCount>128 )
	{
		MessageBox( _T("The # of Coil must between 1 to 128 !") );
		return;
	}

	// the Device ID
	GetDlgItemText(IDC_EDIT_DEVICEID,szwTemp, 80*sizeof(TCHAR));	
	wDeviceID = (WORD)_wtoi(szwTemp);

	// the start address to read
	GetDlgItemText(IDC_EDIT_STARTADDRESS,szwTemp, 80*sizeof(TCHAR));
	wStartAddress = (WORD)_wtoi(szwTemp);

    // get the 5000/TCP's IP Address
	GetDlgItemText(IDC_EDIT_IPADDRESS,szwIPAddress,20);
    
	//--- try to create a connection to 5000/TCP ---
    iRetVal=ADAMTCP_Connect(szwIPAddress,DEFAULT_PORT,
				  iConnectionTimeout, iSendTimeout, iReceiveTimeout);

    if( iRetVal<0 )
    {    
        MessageBox( _T("ADAMTCP_Connect() Failure !!!") );
        return;
    }

    //--- reading the coils ---
    iRetVal=ADAMTCP_ReadCoil(szwIPAddress, wDeviceID, wStartAddress, wCount, wData);
    if( iRetVal )
    {
		MessageBox( _T("ADAMTCP_ReadCoil() Failure !!!") );
        ADAMTCP_Disconnect();
        return;
    }

	((CListBox*)GetDlgItem(IDC_LIST_COILVALUE))->ResetContent();
	for(i=0,j=wStartAddress; i<wCount; i++,j++)
	{
		strTemp.Format( _T("Address:%d   Value:%d"),j,wData[i]);
   	    ((CListBox*)GetDlgItem(IDC_LIST_COILVALUE))->InsertString( -1, strTemp );
	}

    //--- disconnt connection to 5000/TCP ---
    ADAMTCP_Disconnect();
	
}
